import * as THREE from 'three';
import { IParticleSystem, IParticleOptions, vectorTuple, particleTuple, color, IShape } from './types';
import { Object3D } from 'three';
export default class ParticleSystem implements IParticleSystem {
    color: color;
    duration: number;
    elapsedTime: number;
    initialRotationRange: vectorTuple;
    isPlaying: boolean;
    loop: boolean;
    maxParticleSize: number;
    maxParticles: number;
    minParticleSize: number;
    particleLifetime: number;
    particleQueue: particleTuple[];
    particleVelocity: number;
    particlesPerSecond: number;
    playOnLoad: boolean;
    radius: THREE.Vector3;
    rotationRate: number;
    scene: Object3D | null;
    shape: IShape;
    startTime: number;
    target: Object3D;
    worldSpace: boolean;
    constructor(target: Object3D, options: IParticleOptions);
    createPaticle(): void;
    private findSceneObject;
    removeParticles(particles: particleTuple[]): void;
    update(deltaTime?: number): void;
    play(): void;
    pause(): void;
    clear(): void;
    stop(): void;
}
