import * as THREE from 'three';
import { IShape, vectorTuple } from '../types';
export default class BaseShape implements IShape {
    geometry: THREE.Geometry;
    bakedVertices: number;
    randomPoints: Array<vectorTuple>;
    constructor(geometry: THREE.Geometry, ΘX: number, ΘY: number, ΘZ: number, bakedVertices: number | null);
    getVertex(): any;
    /**
     * This method only works with enclosed shapes. So, if you provide a donut,
     * it will not have a hole... Currently researching some possible solutions
     */
    generateRandomPoint(): vectorTuple;
    bakeRandomValues(verts: number): void;
}
