"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var random_1 = require("../utils/random");
var three_1 = require("three");
var BaseShape = /** @class */ (function () {
    function BaseShape(geometry, ΘX, ΘY, ΘZ, bakedVertices) {
        this.bakedVertices = 100;
        this.randomPoints = [];
        this.geometry = geometry;
        this.geometry.computeBoundingBox();
        this.bakedVertices = bakedVertices || 100;
        if (this.bakedVertices)
            this.bakeRandomValues(this.bakedVertices);
    }
    BaseShape.prototype.getVertex = function () {
        if (this.bakedVertices)
            return random_1.randomArrayItem(this.randomPoints);
        return this.generateRandomPoint();
    };
    /**
     * This method only works with enclosed shapes. So, if you provide a donut,
     * it will not have a hole... Currently researching some possible solutions
     */
    BaseShape.prototype.generateRandomPoint = function () {
        // Get two random vertices to lerp a value between
        var a = random_1.randomArrayItem(this.geometry.vertices);
        var b = random_1.randomArrayItem(this.geometry.vertices);
        var scalar = Math.random();
        var x = random_1.randomBoundedFloat(this.geometry.boundingBox.min.x, this.geometry.boundingBox.max.x);
        var y = random_1.randomBoundedFloat(this.geometry.boundingBox.min.y, this.geometry.boundingBox.max.y);
        var z = random_1.randomBoundedFloat(this.geometry.boundingBox.min.z, this.geometry.boundingBox.max.z);
        // (x1, y1, z1) + scalar * ((x2, y2, z2) - (x1, y1, z1))
        b.sub(a);
        b.multiplyScalar(scalar);
        a.add(b);
        // Placeholder values. Todo: implement proper u and v. Half of the logic is there but I just
        // need to figure out the 3D projection of ΘXZ and ΘXY
        var vector = new three_1.Vector3(0, Math.PI, 0); // Adjacent to surface
        return [new three_1.Vector3(x, y, z), vector];
    };
    BaseShape.prototype.bakeRandomValues = function (verts) {
        for (var i = 0; i < verts; i++) {
            this.randomPoints.push(this.generateRandomPoint());
        }
    };
    return BaseShape;
}());
exports.default = BaseShape;
